program console;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  coninp_h in 'coninp_h.pas',
  coninph2 in 'coninph2.pas',
  coninph3 in 'coninph3.pas',
  coninp_p in 'coninp_p.pas',
  console_h in 'console_h.pas';

var
  console_handler: TCustomizeablePrintableConsoleHandler;
  parser: TAdvancedConsoleInputParser;
  input_handler: TConsoleInputHandler;

  input: String;

begin

  WriteLn('Console input handler demo - (c) by Dust Signs Andreas Unterweger 2006');
  WriteLn('======================================================================');
  WriteLn;

  parser := TAdvancedConsoleInputParser.Create;
  input_handler := TConsoleInputHandler.Create;
  console_handler := TCustomizeablePrintableConsoleHandler.Create(parser, input_handler, GetCurrentDir);

  input_handler.RegisterCommandHandler(EchoCommandHandler); //Register command handlers
  input_handler.RegisterCommandHandler(ExitCommandHandler);
  input_handler.RegisterCommandHandler(AboutCommandHandler);
//  input_handler.RegisterCommandHandler(StateCommandHandler); //Remove the comment if you want to use the "cs" function
  input_handler.RegisterCommandHandler(ChangeDirectoryCommandHandler);
  input_handler.RegisterCommandHandler(ListDirectoryCommandHandler);

  while true do begin //Endless loop
    ReadLn(input);
    if not console_handler.Execute(input) then
      break; //Break if Execute returns false (HR_REQUIRES_EXIT)
    end;

  FreeAndNil(console_handler);
  FreeAndNil(input_handler);
  FreeAndNil(parser);

end.
